-- settings ==============================================================================================================
	local version = "v3.08 (08-05-2011)";
	local soundpath = "Interface\\AddOns\\Killshot\\sounds\\";
	local currentSavedVar = 2;
	local maxAnnounces = 4;
	local timePerAnnounce = 15;
	local timeBetweenReceives = 0.5;
	local timeBeforeLastDamageDealerResets = 2.0;
	local audiofiles = 14;
	local multikillTime = 15;
	local showRealms = false;
	local testGivesRealKill = false;
	local testVictim = "TEST_VICTIM";
	local multikillSound = "sp0\\sp0-1.mp3";
	local executeSound = "sp0\\sp0-2.mp3";
	
	-- prefix ============================================================================================================
		local Prefix = "kshot_";
		
		local Prefix_VersionResponse = "vr";
		local Prefix_StreakAnnounce = "sa";
		
		local Prefix_Guild = "g_";
		local Prefix_Raid = "r_";
		local Prefix_BG = "bg_";
		
		local Prefix_VersionRequest = "vq";
		local Prefix_Kill = "k_";
		local Prefix_MultiKill = "m_";
		local Prefix_Death = "d_";
		
		local Prefix_Text = "t";
		local Prefix_Sound = "s";
	-- prefix ============================================================================================================
-- settings ==============================================================================================================


-- init vars =============================================================================================================
	local loaded = 0;
	local announces = 0;
	local lastAnnounceCheckTime = GetTime();
	
	local lastTextReceivedFrom = "";
	local lastTextReceivedTime = GetTime();
	local lastSoundReceivedFrom = "";
	local lastSoundReceivedTime = GetTime();
	
	local lastMultiTextReceivedFrom = "";
	local lastMultiTextReceivedTime = GetTime();
	local lastMultiSoundReceivedFrom = "";
	local lastMultiSoundReceivedTime = GetTime();
	
	local lastVersionResponseSendTo = "";
	local lastVersionResponseSendToTime = GetTime();
	
	local lastDamageDealer = "";
	local lastDamageDealerTimeAgo = GetTime();
	
	local lastTarget = "";
	
	local killingstreakPvE = 0;
	local lastKill = GetTime();
	local multistreak = 0;
	
	local playername = UnitName("player");
-- init vars =============================================================================================================


-- load vars =============================================================================================================
	local frame = CreateFrame("FRAME");
	frame:RegisterEvent("ADDON_LOADED");
	
	
	function frame:OnEvent(event)
		if (event == "ADDON_LOADED") then
			if (loaded == 0) then
				loaded = 1;
				if (saved == currentSavedVar) then
					kshot:Print("Killshot preferences are loading... ");
					
					killingstreak = kshot:checkLoadedVar(killingstreak, "killingstreak", 0);
					soundpack = kshot:checkLoadedVar(soundpack, "soundpack", "sp1normal");
					randomKillMessages = kshot:checkLoadedVar(randomKillMessages, "randomKillMessages", 1);
					killMessage1 = kshot:checkLoadedVar(killMessage1, "killMessage1", "pwned $v! Streak of $s!");
					killMessage2 = kshot:checkLoadedVar(killMessage2, "killMessage2", "pwned $v! Streak of $s!");
					killMessage3 = kshot:checkLoadedVar(killMessage3, "killMessage3", "pwned $v! Streak of $s!");
					killMessage4 = kshot:checkLoadedVar(killMessage4, "killMessage4", "pwned $v! Streak of $s!");
					killMessage5 = kshot:checkLoadedVar(killMessage5, "killMessage5", "pwned $v! Streak of $s!");
					killMessage6 = kshot:checkLoadedVar(killMessage6, "killMessage6", "pwned $v! Streak of $s!");
					killMessage7 = kshot:checkLoadedVar(killMessage7, "killMessage7", "pwned $v! Streak of $s!");
					killMessage8 = kshot:checkLoadedVar(killMessage8, "killMessage8", "pwned $v! Streak of $s!");
					killMessage9 = kshot:checkLoadedVar(killMessage9, "killMessage9", "pwned $v! Streak of $s!");
					killMessage10 = kshot:checkLoadedVar(killMessage10, "killMessage10", "pwned $v! Streak of $s!");
					sound = kshot:checkLoadedVar(sound, "sound", true);
					scrollingtext = kshot:checkLoadedVar(scrollingtext, "scrollingtext", true);
					chattext = kshot:checkLoadedVar(chattext, "chattext", true);
					emote = kshot:checkLoadedVar(emote, "emote", true);
					solo = kshot:checkLoadedVar(solo, "solo", false);
					maxkillingstreak = kshot:checkLoadedVar(maxkillingstreak, "maxkillingstreak", 0);
					totalkillingblows = kshot:checkLoadedVar(totalkillingblows, "totalkillingblows", 0);
					killingstreaktimes = kshot:checkLoadedVar(killingstreaktimes, "killingstreaktimes", 0);
					CheckVersionGuild = kshot:checkLoadedVar(CheckVersionGuild, "CheckVersionGuild", true);
					CheckVersionRaid = kshot:checkLoadedVar(CheckVersionRaid, "CheckVersionRaid", true);
					CheckVersionBG = kshot:checkLoadedVar(CheckVersionBG, "CheckVersionBG", true);
					SendToGuild = kshot:checkLoadedVar(SendToGuild, "SendToGuild", true);
					SendToRaid = kshot:checkLoadedVar(SendToRaid, "SendToRaid", true);
					SendToBG = kshot:checkLoadedVar(SendToBG, "SendToBG", true);
					ReceiveFromGuild = kshot:checkLoadedVar(ReceiveFromGuild, "ReceiveFromGuild", true);
					ReceiveFromRaid = kshot:checkLoadedVar(ReceiveFromRaid, "ReceiveFromRaid", true);
					ReceiveFromBG = kshot:checkLoadedVar(ReceiveFromBG, "ReceiveFromBG", true);
					sendwhat = kshot:checkLoadedVar(sendwhat, "sendwhat", "streak1");
					StreakAnnounceGuild = kshot:checkLoadedVar(StreakAnnounceGuild, "StreakAnnounceGuild", true);
					StreakAnnounceRaid = kshot:checkLoadedVar(StreakAnnounceRaid, "StreakAnnounceRaid", true);
					StreakAnnounceBG = kshot:checkLoadedVar(StreakAnnounceBG, "StreakAnnounceBG", true);
					YourDeathMessages = kshot:checkLoadedVar(YourDeathMessages, "YourDeathMessages", true);
					YourDeathSounds = kshot:checkLoadedVar(YourDeathSounds, "YourDeathSounds", true);
					OtherDeathMessages = kshot:checkLoadedVar(OtherDeathMessages, "OtherDeathMessages", true);
					OtherDeathSounds = kshot:checkLoadedVar(OtherDeathSounds, "OtherDeathSounds", true);
					ReceiveDeathsFromGuild = kshot:checkLoadedVar(ReceiveDeathsFromGuild, "ReceiveDeathsFromGuild", true);
					ReceiveDeathsFromRaid = kshot:checkLoadedVar(ReceiveDeathsFromRaid, "ReceiveDeathsFromRaid", true);
					ReceiveDeathsFromBG = kshot:checkLoadedVar(ReceiveDeathsFromBG, "ReceiveDeathsFromBG", true);
					ResetStreakOnLogin = kshot:checkLoadedVar(ResetStreakOnLogin, "ResetStreakOnLogin", false);
					ResetStreakOnZoneChange = kshot:checkLoadedVar(ResetStreakOnZoneChange, "ResetStreakOnZoneChange", false);
					PvP = kshot:checkLoadedVar(PvP, "PvP", true);
					PvE = kshot:checkLoadedVar(PvE, "PvE", true);
					PvE_Random = kshot:checkLoadedVar(PvE_Random, "PvE_Random", false);
					maxmultistreak = kshot:checkLoadedVar(maxmultistreak, "maxmultistreak", 0);
					totalmultistreak = kshot:checkLoadedVar(totalmultistreak, "totalmultistreak", 0);
					YourMultiKillMessages = kshot:checkLoadedVar(YourMultiKillMessages, "YourMultiKillMessages", true);
					YourMultiKillSounds = kshot:checkLoadedVar(YourMultiKillSounds, "YourMultiKillSounds", true);
					OtherMultiKillMessages = kshot:checkLoadedVar(OtherMultiKillMessages, "OtherMultiKillMessages", true);
					OtherMultiKillSounds = kshot:checkLoadedVar(OtherMultiKillSounds, "OtherMultiKillSounds", true);
					ShowStreakOnLogin = kshot:checkLoadedVar(ShowStreakOnLogin, "ShowStreakOnLogin", true);
					ShowStreakOnZoneChange = kshot:checkLoadedVar(ShowStreakOnZoneChange, "ShowStreakOnZoneChange", true);
					ScreenshotOnKill = kshot:checkLoadedVar(ScreenshotOnKill, "ScreenshotOnKill", false);
					ScreenshotOnMultiKill = kshot:checkLoadedVar(ScreenshotOnMultiKill, "ScreenshotOnMultiKill", true);
					ScreenshotOnDeath = kshot:checkLoadedVar(ScreenshotOnDeath, "ScreenshotOnDeath", false);
					ScreenshotOnNewHighestStreak = kshot:checkLoadedVar(ScreenshotOnNewHighestStreak, "ScreenshotOnNewHighestStreak", true);
					ScreenshotOnNewHighestMultiStreak = kshot:checkLoadedVar(ScreenshotOnNewHighestMultiStreak, "ScreenshotOnNewHighestMultiStreak", true);
					YourKillMessages = kshot:checkLoadedVar(YourKillMessages, "YourKillMessages", true);
					YourKillSounds = kshot:checkLoadedVar(YourKillSounds, "YourKillSounds", true);
					OtherKillMessages = kshot:checkLoadedVar(OtherKillMessages, "OtherKillMessages", true);
					OtherKillSounds = kshot:checkLoadedVar(OtherKillSounds, "OtherKillSounds", true);
					executeSoundNPC = kshot:checkLoadedVar(executeSoundNPC, "executeSoundNPC", true);
					executeSoundPlayer = kshot:checkLoadedVar(executeSoundPlayer, "executeSoundPlayer", true);
					
					kshot:Print("Killshot preferences are loaded. ");
					
					
					if (ResetStreakOnLogin == true) then
						kshot:ResetStreak();
					elseif (ShowStreakOnLogin == true) then
						kshot:EchoStreakIfHigherThanZero();
					end
					
				else
					kshot:ResetAll();
				end
			end
		end
	end
	
	
	frame:SetScript("OnEvent", frame.OnEvent);
	kshot = LibStub("AceAddon-3.0"):NewAddon("kshot", "AceEvent-3.0", "AceConsole-3.0", "LibSink-2.0");
-- load vars =============================================================================================================


-- window ================================================================================================================
	local function makeInfo() 
		local array = { 
			type = "group",
			name = "Killshot",
			args = {
				info_version = {
					type = "description",
					name = version .. "\n\n\nCurrent killing streak: " .. killingstreak .. "\nHighest killing streak: " .. maxkillingstreak .. "\nAverage killing streak: " .. kshot:getStreakAverage() .. "\n\nTotal killingblows: " .. totalkillingblows .. "\nAmount of killingstreaks: " .. killingstreaktimes .. "\n\nHighest multi-kill streak: " .. maxmultistreak .. "\nTotal multi-kills: " .. totalmultistreak .. "\n\n",
					order = 10
				},
				info_streakreset = {
					type = 'execute',
					name = 'Reset Current Streak',
					func = function() kshot:ResetStreak() end,
					width = "full",
					order = 20
				},
				info_streakresetall = {
					type = 'execute',
					name = 'Reset Streak Stats',
					func = function() kshot:ResetStreakInfo() end,
					width = "full",
					order = 30
				},
				info_resetall = {
					type = 'execute',
					name = 'Reset All Settings',
					func = function() kshot:ResetAll() end,
					width = "full",
					order = 40
				}
			}
		}
		return array;
	end
	
	local function makeSettings() 
		local array = { 
			type = "group",
			name = "Settings",
			args = {
				settings_test = {
					type = 'execute',
					name = 'Killshot Test',
					func = function() kshot:Test() end,
					width = "full",
					order = 10
				},
				settings_soundpack = {
					type = 'select',
					name = 'Select Soundpack',
					desc = 'Select Soundpack',
					get = function() return soundpack end,
					set = function(info, var) soundpack = var end,
					values = {
						sp1normal = "1. Normal",
						sp2female = "2. Female",
						sp3sexy = "3. Sexy",
						sp4custom = "4. Custom"
					},
					order = 20
				},
				settings_emote = {
					type = 'toggle',
					name = 'Enable all Emote Messages',
					get = function() return emote end,
					set = function(info, var) emote = var end,
					width = "full",
					order = 40
				},
				settings_scrollingtext = {
					type = 'toggle',
					name = 'Enable all Scrolling Text Messages',
					get = function() return scrollingtext end,
					set = function(info, var) scrollingtext = var end,
					width = "full",
					order = 50
				},
				settings_chattext = {
					type = 'toggle',
					name = 'Enable all Chat Text Messages',
					get = function() return chattext end,
					set = function(info, var) chattext = var end,
					width = "full",
					order = 55
				},
				settings_sound = {
					type = 'toggle',
					name = 'Enable all Sounds',
					get = function() return sound end,
					set = function(info, var) sound = var end,
					width = "full",
					order = 60
				},
				settings_empty_line_1 = {
					type = "description",
					name = "\n",
					order = 70
				},
				settings_description_pvp_pve = {
					type = "description",
					name = "PvE kills will only play a sound. PvE kills won't share, and they won't modify your streak-data. ",
					order = 80
				},
				settings_pvp = {
					type = 'toggle',
					name = 'Enable PvP Kills',
					get = function() return PvP end,
					set = function(info, var) PvP = var end,
					width = "full",
					order = 90
				},
				settings_pve = {
					type = 'toggle',
					name = "Enable PvE Kills",
					get = function() return PvE end,
					set = function(info, var) PvE = var end,
					width = "full",
					order = 100
				},
				settings_pve_random = {
					type = 'toggle',
					name = "PvE kills play random sounds",
					get = function() return ((PvE_Random == true) and (PvE == true)) end,
					set = function(info, var) PvE_Random = var end,
					width = "full",
					order = 110
				},
				settings_empty_line_2 = {
					type = "description",
					name = "\n",
					order = 120
				},
				settings_showstreakonlogin = {
					type = 'toggle',
					name = 'Show your streak on login',
					get = function() return ShowStreakOnLogin end,
					set = 	function(info, var)
								ShowStreakOnLogin = var;
								if (var == true) then
									ResetStreakOnLogin = false;
								end
							end,
					width = "full",
					order = 130
				},
				settings_resetstreakonlogin = {
					type = 'toggle',
					name = 'Reset your streak on login',
					get = function() return ResetStreakOnLogin end,
					set = 	function(info, var)
								ResetStreakOnLogin = var;
								if (var == true) then
									ShowStreakOnLogin = false;
								end
							end,
					width = "full",
					order = 140
				},
				settings_showstreakonzonechange = {
					type = 'toggle',
					name = 'Show your streak on zone change',
					get = function() return ShowStreakOnZoneChange end,
					set = 	function(info, var)
								ShowStreakOnZoneChange = var;
								if (var == true) then
									ResetStreakOnZoneChange = false;
								end
							end,
					width = "full",
					order = 150
				},
				settings_resetstreakonzonechange = {
					type = 'toggle',
					name = 'Reset your streak on zone change',
					get = function() return ResetStreakOnZoneChange end,
					set = 	function(info, var)
								ResetStreakOnZoneChange = var;
								if (var == true) then
									ShowStreakOnZoneChange = false;
								end
							end,
					width = "full",
					order = 160
				}
			}
		}
		return array;
	end
	
	local function makeStreakMessages()
		local array = { 
			type = "group",
			name = "About",
			args = {
				messages_slider = {
					type = 'range',
					name = 'Amount of random streak messages',
					isPercent = false,
					min = 1, max = 10, bigStep = 1,
					get = function() return randomKillMessages end,
					set = function(info, var) randomKillMessages = var end,
					width = "full",
					order = 10
				},
				message_1 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 1) end,
					name = "Messages",
					desc = "$v = victim, $s = streak",
					get = function() return killMessage1 end,
					set = function(info, var) killMessage1 = var end,
					width = "full",
					order = 20
				},
				message_2 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 2) end,
					name = "",
					desc = "",
					get = function() return killMessage2 end,
					set = function(info, var) killMessage2 = var end,
					width = "full",
					order = 30
				},
				message_3 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 3) end,
					name = "",
					desc = "",
					get = function() return killMessage3 end,
					set = function(info, var) killMessage3 = var end,
					width = "full",
					order = 40
				},
				message_4 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 4) end,
					name = "",
					desc = "",
					get = function() return killMessage4 end,
					set = function(info, var) killMessage4 = var end,
					width = "full",
					order = 50
				},
				message_5 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 5) end,
					name = "",
					desc = "",
					get = function() return killMessage5 end,
					set = function(info, var) killMessage5 = var end,
					width = "full",
					order = 60
				},
				message_6 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 6) end,
					name = "",
					desc = "",
					get = function() return killMessage6 end,
					set = function(info, var) killMessage6 = var end,
					width = "full",
					order = 70
				},
				message_7 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 7) end,
					name = "",
					desc = "",
					get = function() return killMessage7 end,
					set = function(info, var) killMessage7 = var end,
					width = "full",
					order = 80
				},
				message_8 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 8) end,
					name = "",
					desc = "",
					get = function() return killMessage8 end,
					set = function(info, var) killMessage8 = var end,
					width = "full",
					order = 90
				},
				message_9 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 9) end,
					name = "",
					desc = "",
					get = function() return killMessage9 end,
					set = function(info, var) killMessage9 = var end,
					width = "full",
					order = 100
				},
				message_10 = {
					type = 'input',
					hidden = function() return (randomKillMessages < 10) end,
					name = "",
					desc = "",
					get = function() return killMessage10 end,
					set = function(info, var) killMessage10 = var end,
					width = "full",
					order = 110
				}
			}
		}
		return array;
	end
	
	local function makeScreenshotSettings()
		local array = { 
			type = "group",
			name = "Screenshot Settings",
			args = {
				ss_kill = {
					type = 'toggle',
					name = 'Screenshot on Kill',
					get = function() return ScreenshotOnKill end,
					set = function(info, var) ScreenshotOnKill = var end,
					width = "full",
					order = 10
				},
				ss_multikill = {
					type = 'toggle',
					name = 'Screenshot on Multi-Kill',
					get = function() return ScreenshotOnMultiKill end,
					set = function(info, var) ScreenshotOnMultiKill = var end,
					width = "full",
					order = 20
				},
				ss_death = {
					type = 'toggle',
					name = 'Screenshot on Death',
					get = function() return ScreenshotOnDeath end,
					set = function(info, var) ScreenshotOnDeath = var end,
					width = "full",
					order = 30
				},
				ss_empty_line_1 = {
					type = "description",
					name = "\n",
					order = 40
				},
				ss_new_streak = {
					type = 'toggle',
					name = 'Screenshot on New Streak Record',
					get = function() return ScreenshotOnNewHighestStreak end,
					set = function(info, var) ScreenshotOnNewHighestStreak = var end,
					width = "full",
					order = 50
				},
				ss_new_multi_streak = {
					type = 'toggle',
					name = 'Screenshot on New Multi-Kill Streak Record',
					get = function() return ScreenshotOnNewHighestMultiStreak end,
					set = function(info, var) ScreenshotOnNewHighestMultiStreak = var end,
					width = "full",
					order = 60
				}
			}
		}
		return array;
	end
	
	local function makeMessageSettings()
		local array = { 
			type = "group",
			name = "Message/Sound Settings",
			args = {
				ms_executesound_npc = {
					type = 'toggle',
					name = 'Play a sound when targetted NPC is below 20% HP',
					get = function() return ((executeSoundNPC == true) and (sound == true)) end,
					set = function(info, var) executeSoundNPC = var end,
					width = "full",
					order = 10
				},
				ms_executesound_player = {
					type = 'toggle',
					name = 'Play a sound when targetted Player is below 20% HP',
					get = function() return ((executeSoundPlayer == true) and (sound == true)) end,
					set = function(info, var) executeSoundPlayer = var end,
					width = "full",
					order = 20
				},
				ms_empty_line_1 = {
					type = "description",
					name = "\n",
					order = 30
				},
				ms_yourkillmessages = {
					type = 'toggle',
					name = 'Enable your Kill Messages',
					get = function() return ((YourKillMessages == true) and (scrollingtext == true)) end,
					set = function(info, var) YourKillMessages = var end,
					width = "full",
					order = 40
				},
				ms_yourkillsounds = {
					type = 'toggle',
					name = 'Enable your Kill Sounds',
					get = function() return ((YourKillSounds == true) and (sound == true)) end,
					set = function(info, var) YourKillSounds = var end,
					width = "full",
					order = 50
				},
				ms_otherkillmessages = {
					type = 'toggle',
					name = 'Enable others Kill Messages',
					get = function() return ((OtherKillMessages == true) and (scrollingtext == true) and (solo == false)) end,
					set = function(info, var) OtherKillMessages = var end,
					width = "full",
					order = 60
				},
				ms_otherkillsounds = {
					type = 'toggle',
					name = 'Enable others Kill Sounds',
					get = function() return ((OtherKillSounds == true) and (sound == true) and (solo == false)) end,
					set = function(info, var) OtherKillSounds = var end,
					width = "full",
					order = 70
				},
				ms_empty_line_2 = {
					type = "description",
					name = "\n",
					order = 80
				},
				ms_yourmultikillmessages = {
					type = 'toggle',
					name = 'Enable your Multi-Kill Messages',
					get = function() return ((YourMultiKillMessages == true) and (scrollingtext == true)) end,
					set = function(info, var) YourMultiKillMessages = var end,
					width = "full",
					order = 90
				},
				ms_yourmultikillsounds = {
					type = 'toggle',
					name = 'Enable your Multi-Kill Sounds',
					get = function() return ((YourMultiKillSounds == true) and (sound == true)) end,
					set = function(info, var) YourMultiKillSounds = var end,
					width = "full",
					order = 100
				},
				ms_othermultikillmessages = {
					type = 'toggle',
					name = 'Enable others Multi-Kill Messages',
					get = function() return ((OtherMultiKillMessages == true) and (scrollingtext == true) and (solo == false)) end,
					set = function(info, var) OtherMultiKillMessages = var end,
					width = "full",
					order = 110
				},
				ms_othermultikillsounds = {
					type = 'toggle',
					name = 'Enable others Multi-Kill Sounds',
					get = function() return ((OtherMultiKillSounds == true) and (sound == true) and (solo == false)) end,
					set = function(info, var) OtherMultiKillSounds = var end,
					width = "full",
					order = 120
				},
				ms_empty_line_3 = {
					type = "description",
					name = "\n",
					order = 130
				},
				ms_yourdeathmessages = {
					type = 'toggle',
					name = 'Enable your Death Messages',
					get = function() return ((YourDeathMessages == true) and (scrollingtext == true)) end,
					set = function(info, var) YourDeathMessages = var end,
					width = "full",
					order = 140
				},
				ms_yourdeathsounds = {
					type = 'toggle',
					name = 'Enable your Death Sounds',
					get = function() return ((YourDeathSounds == true) and (sound == true)) end,
					set = function(info, var) YourDeathSounds = var end,
					width = "full",
					order = 150
				},
				ms_otherdeathmessages = {
					type = 'toggle',
					name = 'Enable others Death Messages',
					get = function() return ((OtherDeathMessages == true) and (scrollingtext == true) and (solo == false)) end,
					set = function(info, var) OtherDeathMessages = var end,
					width = "full",
					order = 160
				},
				ms_otherdeathsounds = {
					type = 'toggle',
					name = 'Enable others Death Sounds',
					get = function() return ((OtherDeathSounds == true) and (sound == true) and (solo == false)) end,
					set = function(info, var) OtherDeathSounds = var end,
					width = "full",
					order = 170
				}
			}
		}
		return array;
	end
	
	local function makeShareSettings() 
		local array = { 
			type = "group",
			name = "Kills Share Settings",
			args = {
				ss_solo = {
					type = 'toggle',
					name = 'Solo Mode (blocks all sending/receiving)',
					get = function() return solo end,
					set = function(info, var) solo = var end,
					width = "full",
					order = 10
				},
				ss_empty_line_1 = {
					type = "description",
					name = "\n",
					order = 20
				},
				ss_sendguild = {
					type = 'toggle',
					name = 'Send kills to Guild',
					get = function() return ((SendToGuild == true) and (solo == false)) end,
					set = function(info, var) SendToGuild = var end,
					width = "full",
					order = 30
				},
				ss_sendraid = {
					type = 'toggle',
					name = 'Send kills to Party/Raid',
					get = function() return ((SendToRaid == true) and (solo == false)) end,
					set = function(info, var) SendToRaid = var end,
					width = "full",
					order = 40
				},
				ss_sendbg = {
					type = 'toggle',
					name = 'Send kills to BG',
					get = function() return ((SendToBG == true) and (solo == false)) end,
					set = function(info, var) SendToBG = var end,
					width = "full",
					order = 50
				},
				ss_empty_line_2 = {
					type = "description",
					name = "\n",
					order = 60
				},
				ss_receiveguild = {
					type = 'toggle',
					name = 'Receive kills from Guild',
					get = function() return ((ReceiveFromGuild == true) and (solo == false)) end,
					set = function(info, var) ReceiveFromGuild = var end,
					width = "full",
					order = 70
				},
				ss_receiveraid = {
					type = 'toggle',
					name = 'Receive kills from Party/Raid',
					get = function() return ((ReceiveFromRaid == true) and (solo == false)) end,
					set = function(info, var) ReceiveFromRaid = var end,
					width = "full",
					order = 80
				},
				ss_receivebg = {
					type = 'toggle',
					name = 'Receive kills from BG',
					get = function() return ((ReceiveFromBG == true) and (solo == false)) end,
					set = function(info, var) ReceiveFromBG = var end,
					width = "full",
					order = 90
				},
				ss_empty_line_3 = {
					type = "description",
					name = "\n",
					order = 100
				},
				ss_receivedeathsguild = {
					type = 'toggle',
					name = 'Receive deaths from Guild',
					get = function() return ((ReceiveDeathsFromGuild == true) and (solo == false)) end,
					set = function(info, var) ReceiveDeathsFromGuild = var end,
					width = "full",
					order = 110
				},
				ss_receivedeathsraid = {
					type = 'toggle',
					name = 'Receive deaths from Party/Raid',
					get = function() return ((ReceiveDeathsFromRaid == true) and (solo == false)) end,
					set = function(info, var) ReceiveDeathsFromRaid = var end,
					width = "full",
					order = 120
				},
				ss_receivedeathsbg = {
					type = 'toggle',
					name = 'Receive deaths from BG',
					get = function() return ((ReceiveDeathsFromBG == true) and (solo == false)) end,
					set = function(info, var) ReceiveDeathsFromBG = var end,
					width = "full",
					order = 130
				}
			}
		}
		return array;
	end
	
	local function makeStreakAnnouncements() 
		local array = { 
			type = "group",
			name = "Announce Streak Data",
			args = {
				sa_sendwhat = {
					type = 'select',
					name = 'Select Data to Send',
					desc = 'Select Data to Send',
					get = function() return sendwhat end,
					set = function(info, var) sendwhat = var end,
					values = {
						streak1 = "Current Streak",
						streak2max = "Highest Streak",
						streak3avg = "Average Streak",
						streak4multimax = "Highest Multi-Kill Streak",
						streak5multitotal = "Total Multi-Kills"
					},
					order = 10
				},
				sa_guild = {
					type = 'toggle',
					name = 'Guild',
					get = function() return StreakAnnounceGuild end,
					set = function(info, var) StreakAnnounceGuild = var end,
					width = "full",
					order = 20
				},
				sa_raid = {
					type = 'toggle',
					name = 'Party/Raid',
					get = function() return StreakAnnounceRaid end,
					set = function(info, var) StreakAnnounceRaid = var end,
					width = "full",
					order = 30
				},
				sa_bg = {
					type = 'toggle',
					name = 'BG',
					get = function() return StreakAnnounceBG end,
					set = function(info, var) StreakAnnounceBG = var end,
					width = "full",
					order = 40
				},
				sa_send = {
					type = 'execute',
					name = 'Send',
					func = function() kshot:EchoStreakData(sendwhat, StreakAnnounceGuild, StreakAnnounceRaid, StreakAnnounceBG) end,
					width = "full",
					order = 50
				}
			}
		}
		return array;
	end
	
	local function makeCompareVersions() 
		local array = { 
			type = "group",
			name = "Compare Versions",
			args = {
				version_guild = {
					type = 'toggle',
					name = 'Guild',
					get = function() return CheckVersionGuild end,
					set = function(info, var) CheckVersionGuild = var end,
					width = "full",
					order = 10
				},
				version_raid = {
					type = 'toggle',
					name = 'Party/Raid',
					get = function() return CheckVersionRaid end,
					set = function(info, var) CheckVersionRaid = var end,
					width = "full",
					order = 20
				},
				version_bg = {
					type = 'toggle',
					name = 'BG',
					get = function() return CheckVersionBG end,
					set = function(info, var) CheckVersionBG = var end,
					width = "full",
					order = 30
				},
				version_check = {
					type = 'execute',
					name = 'Compare your version with others',
					func = function() kshot:CheckVersions(CheckVersionGuild, CheckVersionRaid, CheckVersionBG) end,
					width = "full",
					order = 40
				}
			}
		}
		return array;
	end
	
	local function makeAbout() 
		local array = { 
			type = "group",
			name = "About",
			args = {
				about_about = {
					type = "description",
					name = "Author: Zwarmapapa \nE-Mail: zwarmapapa@hotmail.com \nWebsite: zwarmapapa.nl \n\nPlaying Horde on Ahn'Qiraj\nFeel free to add me ingame",
					order = 10
				}
			}
		}
		return array;
	end
	

	function kshot:OnInitialize()
		local window = LibStub("AceConfigRegistry-3.0");
		window:RegisterOptionsTable("Killshot", makeInfo);
		window:RegisterOptionsTable("Killshot Settings", makeSettings);
		window:RegisterOptionsTable("Killshot Streak Messages", makeStreakMessages);
		window:RegisterOptionsTable("Killshot Screenshot Settings", makeScreenshotSettings);
		window:RegisterOptionsTable("Killshot Message/Sound Settings", makeMessageSettings);
		window:RegisterOptionsTable("Killshot Share Settings", makeShareSettings);
		window:RegisterOptionsTable("Killshot Announce Streak Data", makeStreakAnnouncements);
		window:RegisterOptionsTable("Killshot Compare Versions", makeCompareVersions);
		window:RegisterOptionsTable("Killshot About", makeAbout);
		
		local paneel = LibStub("AceConfigDialog-3.0");
		paneel:AddToBlizOptions("Killshot", "Killshot");
		paneel:AddToBlizOptions("Killshot Settings", "Settings", "Killshot");
		paneel:AddToBlizOptions("Killshot Streak Messages", "Streak Messages", "Killshot");
		paneel:AddToBlizOptions("Killshot Screenshot Settings", "Screenshot Settings", "Killshot");
		paneel:AddToBlizOptions("Killshot Message/Sound Settings", "Message/Sound Settings", "Killshot");
		paneel:AddToBlizOptions("Killshot Share Settings", "Share Settings", "Killshot");
		paneel:AddToBlizOptions("Killshot Announce Streak Data", "Announce Streak Data", "Killshot");
		paneel:AddToBlizOptions("Killshot Compare Versions", "Compare Versions", "Killshot");
		paneel:AddToBlizOptions("Killshot About", "About", "Killshot");
		
		
		self:RegisterChatCommand("killshot", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end);
		self:RegisterChatCommand("kshot", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end);
		self:RegisterChatCommand("ks", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end);
	end
-- window ================================================================================================================


-- needed crap ===========================================================================================================
	function kshot:OnEnable()
		self:RegisterEvent("SoundEvent", "SoundEventHandler");
		self:RegisterEvent("CHAT_MSG_ADDON", "AddonMessageHandler");
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEventHandler");
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "ZoneChangedHandler");
	end
	function kshot:checkLoadedVar(var, varname, default)
		if (var == nil) then
			var = default;
			
			if (default == true) then
				default = "true";
			end
			if (default == false) then
				default = "false";
			end
			
			kshot:Print("Loaded "..varname.." = nil, changed it to ["..default.."]");
		end
		
		return var;
	end
	function kshot:SoundEventHandler(sound)
		if not (PlaySoundFile(sound)) then
			self:ScheduleEvent("SoundEvent", 0.2, sound);
		end
	end
	function kshot:ZoneChangedHandler()
		if (ResetStreakOnZoneChange == true) then
			kshot:ResetStreak();
		elseif (ShowStreakOnZoneChange == true) then
			kshot:EchoStreakIfHigherThanZero();
		end
	end
	function kshot:EchoStreakIfHigherThanZero()
		if (killingstreak > 0) then
			kshot:EchoStreak1();
		end
	end
	function kshot:EchoStreak1()
		kshot:EchoStreak(true, false, false, false);
	end
	function kshot:EchoMaxStreak1()
		kshot:EchoMaxStreak(true, false, false, false);
	end
	function kshot:EchoAverageStreak1()
		kshot:EchoAverageStreak(true, false, false, false);
	end
	function kshot:ScrollText(msg, force)
		if ((scrollingtext == true) or (force == true)) then
			if (IsAddOnLoaded("Blizzard_CombatText")) then 
				CombatText_AddMessage(msg, CombatText_StandardSCroll, 1, 0.1, 0.1, "crit", 0);        
			elseif (IsAddOnLoaded("SCT")) then 
				SCT:DisplayText(msg, {r=1.0, g=0.1, b=0.1}, 1, "event", 1, 1);
			end
		end
	end
	function kshot:ChatText(msg)
		if (chattext == true) then
			kshot:Print(msg);
		end
	end
	function kshot:SendVersionResponse(requester, targetGroup)
		kshot:checkPlayerName();
		SendAddonMessage(Prefix..Prefix_VersionResponse, requester .. ":" .. playername .. " is on version " .. version, targetGroup);
	end
	function kshot:CheckGuildVersions()
		if (kshot:Guild(true) == true) then
			kshot:checkPlayerName();
			SendAddonMessage(Prefix..Prefix_Guild..Prefix_VersionRequest, playername, "GUILD");
		end
	end
	function kshot:CheckRaidVersions()
		if (kshot:Party(true) == true) then
			kshot:checkPlayerName();
			SendAddonMessage(Prefix..Prefix_Raid..Prefix_VersionRequest, playername, "PARTY");
		end
		if (kshot:Raid(true) == true) then
			kshot:checkPlayerName();
			SendAddonMessage(Prefix..Prefix_Raid..Prefix_VersionRequest, playername, "RAID");
		end
	end
	function kshot:CheckBGVersions()
		if (kshot:BG(true) == true) then
			kshot:checkPlayerName();
			SendAddonMessage(Prefix..Prefix_BG..Prefix_VersionRequest, playername, "BATTLEGROUND");
		end
	end
	function kshot:PlaySound(soundfilelink)
		if (sound == true) then
			local soundfile = soundpath .. soundfilelink;
			kshot:SoundEventHandler(soundfile);
		end
	end
	function kshot:UpdateAnnounces()
		local Time = GetTime() - lastAnnounceCheckTime;
		while (Time > timePerAnnounce) do
			lastAnnounceCheckTime = lastAnnounceCheckTime + timePerAnnounce;
			Time = GetTime() - lastAnnounceCheckTime;
			if (announces > 0) then
				announces = announces - 1;
			end
		end
	end
	function kshot:getStreakAverage()
		local avgCalc = totalkillingblows/killingstreaktimes;
		if (totalkillingblows == 0) then
			avgCalc = 0;
		end
		return avgCalc;
	end
	function kshot:getStreakMessage(victim, streak)
		local randomInt = math.random(1, randomKillMessages);
		local message = "";
		
		if (randomInt == 1) then
			message = killMessage1;
		elseif (randomInt == 2) then
			message = killMessage2;
		elseif (randomInt == 3) then
			message = killMessage3;
		elseif (randomInt == 4) then
			message = killMessage4;
		elseif (randomInt == 5) then
			message = killMessage5;
		elseif (randomInt == 6) then
			message = killMessage6;
		elseif (randomInt == 7) then
			message = killMessage7;
		elseif (randomInt == 8) then
			message = killMessage8;
		elseif (randomInt == 9) then
			message = killMessage9;
		elseif (randomInt == 10) then
			message = killMessage10;
		end
		
		message = string.gsub(message, "$v", victim);
		message = string.gsub(message, "$s", streak);
		return message;
	end
	function kshot:getName(name)
		if (showRealms == false) then
			local till = string.find(name, "-");
			if not (till == nil) then
				name = string.sub(name, 1, till-1);
			end
		end
		return name;
	end
	function kshot:Screenshot()
		Screenshot();
	end
	function kshot:checkPlayerName()
		if ((playername == nil) or (playername == "")) then
			playername = UnitName("player");
		end
	end
	function kshot:bitBand(flags, objectType)
		if ((flags == nil) or (objectType == nil)) then
			return false;
		else
			return (bit.band(flags, objectType) == objectType);
		end
	end
-- needed crap ===========================================================================================================


-- streak announcements ==================================================================================================
	function kshot:EchoStreakData(what, Guild, Raid, BG)
		if ((kshot:Guild(Guild) == false) and (kshot:Party(Raid) == false) and (kshot:Raid(Raid) == false) and (kshot:BG(BG) == false)) then
			kshot:Print("You can't send your streak-data to no-one!");
		else
			kshot:UpdateAnnounces();
			announces = announces + 1;
			if (announces < maxAnnounces) then
				if (what == "streak1") then
					kshot:EchoStreak(false, Guild, Raid, BG);
				elseif (what == "streak2max") then
					kshot:EchoMaxStreak(false, Guild, Raid, BG);
				elseif (what == "streak3avg") then
					kshot:EchoAverageStreak(false, Guild, Raid, BG);
				elseif (what == "streak4multimax") then
					kshot:EchoMaxMultiKillStreak(false, Guild, Raid, BG)
				elseif (what == "streak5multitotal") then
					kshot:EchoTotalMultiKills(false, Guild, Raid, BG);
				else
					sendwhat = "streak1";
				end
			else
				kshot:Print("Killsot's Anti-Spam stopped your streak-data announcement!");
			end
		end
	end
	
	function kshot:EchoStreak(toSelf, Guild, Raid, BG)
		local msg = " current streak is: " .. killingstreak;
		local what = "current streak";
		kshot:Echo(toSelf, Guild, Raid, BG, msg, what);
	end
	
	function kshot:EchoMaxStreak(toSelf, Guild, Raid, BG)
		local msg = " highest streak is: " .. maxkillingstreak;
		local what = "highest streak";
		kshot:Echo(toSelf, Guild, Raid, BG, msg, what);
	end
	
	function kshot:EchoAverageStreak(toSelf, Guild, Raid, BG)
		local msg = " average streak is: " .. kshot:getStreakAverage();
		local what = "average streak";
		kshot:Echo(toSelf, Guild, Raid, BG, msg, what);
	end
	
	function kshot:EchoMaxMultiKillStreak(toSelf, Guild, Raid, BG)
		local msg = " highest multi-kill streak is: " .. maxmultistreak;
		local what = "highest multi-kill streak";
		kshot:Echo(toSelf, Guild, Raid, BG, msg, what);
	end
	
	function kshot:EchoTotalMultiKills(toSelf, Guild, Raid, BG)
		local msg = " total multi-kills are: " .. totalmultistreak;
		local what = "total multi-kills";
		kshot:Echo(toSelf, Guild, Raid, BG, msg, what);
	end
	
	function kshot:Echo(toSelf, Guild, Raid, BG, msgSend, msgSendWhat)
		if (toSelf == true) then
			kshot:ScrollText("Your" .. msgSend, true);
			kshot:ChatText("Your" .. msgSend);
		else
			kshot:checkPlayerName();
			if (kshot:Guild(Guild) == true) then
				SendAddonMessage(Prefix..Prefix_StreakAnnounce, playername .. "'s" .. msgSend, "GUILD");
				kshot:Print("Your " .. msgSendWhat .. " has been sent to your Guild");
			end
			if (kshot:Party(Raid) == true) then
				SendAddonMessage(Prefix..Prefix_StreakAnnounce, playername .. "'s" .. msgSend, "PARTY");
				kshot:Print("Your " .. msgSendWhat .. " has been sent to your Party");
			end
			if (kshot:Raid(Raid) == true) then
				SendAddonMessage(Prefix..Prefix_StreakAnnounce, playername .. "'s" .. msgSend, "RAID");
				kshot:Print("Your " .. msgSendWhat .. " has been sent to your Raid");
			end
			if (kshot:BG(BG) == true) then
				SendAddonMessage(Prefix..Prefix_StreakAnnounce, playername .. "'s" .. msgSend, "BATTLEGROUND");
				kshot:Print("Your " .. msgSendWhat .. " has been sent to your BG");
			end
		end
	end
	
	function kshot:CheckVersions(Guild, Raid, BG)
		kshot:checkPlayerName();
		kshot:Print(playername .. " is on version " .. version);
		if (kshot:Guild(Guild) == true) then
			kshot:CheckGuildVersions();
		end
		if (kshot:Raid(Raid) == true) then
			kshot:CheckRaidVersions();
		end
		if (kshot:BG(BG) == true) then
			kshot:CheckBGVersions();
		end
	end
-- streak announcements ==================================================================================================


-- main script ===========================================================================================================
	-- soundfile settings ================================================================================================
		function kshot:GetSoundLink(kills)
			local soundpackNr = "1";
			if (soundpack == "sp1normal") then
				soundpackNr = "1";
			elseif (soundpack == "sp2female") then
				soundpackNr = "2";
			elseif (soundpack == "sp3sexy") then
				soundpackNr = "3";
			elseif (soundpack == "sp4custom") then
				soundpackNr = "4";
			else
				soundpack = "sp1normal";
				soundpackNr = "1";
			end
			
			
			local soundfile = "";
			local sp = "sp"..soundpackNr .. "\\" .. "sp"..soundpackNr;
			if (kills > -100 ) then
				if (kills > 19) then soundfile = sp.."-14.mp3";
					elseif (kills > 15) then soundfile = sp.."-13.mp3";
					elseif (kills > 12) then soundfile = sp.."-12.mp3";
					elseif (kills > 10) then soundfile = sp.."-11.mp3";
					elseif (kills >  9) then soundfile = sp.."-10.mp3";
					elseif (kills >  8) then soundfile = sp.."-9.mp3";
					elseif (kills >  7) then soundfile = sp.."-8.mp3";
					elseif (kills >  6) then soundfile = sp.."-7.mp3";
					elseif (kills >  5) then soundfile = sp.."-6.mp3";
					elseif (kills >  4) then soundfile = sp.."-5.mp3";
					elseif (kills >  3) then soundfile = sp.."-4.mp3";
					elseif (kills >  2) then soundfile = sp.."-3.mp3";
					elseif (kills >  1) then soundfile = sp.."-2.mp3";
					elseif (kills >  0) then soundfile = sp.."-1.mp3";
					elseif (kills > -1) then soundfile = sp.."-0.mp3";
				end
			elseif (kills > -200 ) then
				if (kills == -114) then soundfile = sp.."-14.mp3";
					elseif (kills == -113) then soundfile = sp.."-13.mp3";
					elseif (kills == -112) then soundfile = sp.."-12.mp3";
					elseif (kills == -111) then soundfile = sp.."-11.mp3";
					elseif (kills == -110) then soundfile = sp.."-10.mp3";
					elseif (kills == -109) then soundfile = sp.."-9.mp3";
					elseif (kills == -108) then soundfile = sp.."-8.mp3";
					elseif (kills == -107) then soundfile = sp.."-7.mp3";
					elseif (kills == -106) then soundfile = sp.."-6.mp3";
					elseif (kills == -105) then soundfile = sp.."-5.mp3";
					elseif (kills == -104) then soundfile = sp.."-4.mp3";
					elseif (kills == -103) then soundfile = sp.."-3.mp3";
					elseif (kills == -102) then soundfile = sp.."-2.mp3";
					elseif (kills == -101) then soundfile = sp.."-1.mp3";
				end
			end
			return soundfile;
		end
	-- soundfile settings ================================================================================================
	
	-- events ============================================================================================================
		function kshot:CombatLogEventHandler(info, timestamp, event, _, sourceID, sourceName, sourceFlags, destID, destName, destFlags, ...)
			kshot:checkPlayerName();
			if (event == nil) then return end
			if (event == "PARTY_KILL") then
				-- kill ==========================================================
					if (sourceFlags == nil) then return end
					if (destFlags == nil) then return end
					if (kshot:bitBand(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE)) then
						if (destName == nil) then return end
						if (kshot:bitBand(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER)) then
							local VictimName = kshot:getName(destName);
							if (kshot:Arena(true)) then
								VictimName = VictimName .. "(Arena)";
							elseif (kshot:BG(true)) then
								VictimName = VictimName .. "(BG)";
							end
							kshot:KillshotPvP(playername, VictimName);
						else
							kshot:KillshotPvE();
						end
					end
				-- kill ==========================================================
			elseif (event == "UNIT_DIED") then
				-- player died ===================================================
					if (destName == nil) then return end
					if (destName == playername) then
						local Time = GetTime() - lastDamageDealerTimeAgo;
						if (Time > timeBeforeLastDamageDealerResets) then
							lastDamageDealer = "";
						end
						kshot:PlayerDeath(lastDamageDealer);
					end
				-- player died ===================================================
			elseif (string.find(event, "_DAMAGE")) then
				if (destName == nil) then return end
				if (sourceName == nil) then return end
				if not (sourceName == playername) then
					-- player received damage ====================================
						if (kshot:bitBand(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)) then
							lastDamageDealer = kshot:getName(sourceName);
							lastDamageDealerTimeAgo = GetTime();
							if not (kshot:bitBand(sourceFlags, COMBATLOG_OBJECT_TYPE_PLAYER)) then
								lastDamageDealer = lastDamageDealer .. "(NPC)";
							end
							if (kshot:Arena(true)) then
								lastDamageDealer = lastDamageDealer .. "(Arena)";
							elseif (kshot:BG(true)) then
								lastDamageDealer = lastDamageDealer .. "(BG)";
							end
						end
					-- player received damage ====================================
				else
					-- enemy received damage =====================================
						if (kshot:bitBand(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE)) then
							if (UnitName("target") == destName) then
								if ((UnitHealth("target") < UnitHealthMax("target")/5) and (UnitHealth("target") > 0)) then
									if not (UnitName("target") == lastTarget) then
										lastTarget = UnitName("target");
										kshot:PlaySound(executeSound);
									end
								else
									lastTarget = "";
								end
							end
						end
					-- enemy received damage =====================================
				end
			end
		end
		
		function kshot:AddonMessageHandler(info, prefix, text, type, target)
			kshot:checkPlayerName();
			if not (target == playername) then
				
				-- check if it isn't a multi-send ===================================
					local receiveText = true;
					if (target == lastTextReceivedFrom) then
						local Time = GetTime() - lastTextReceivedTime;
						if (Time < timeBetweenReceives) then
							receiveText = false;
						end
					end
					
					local receiveMultiText = true;
					if (target == lastMultiTextReceivedFrom) then
						local Time = GetTime() - lastMultiTextReceivedTime;
						if (Time < timeBetweenReceives) then
							receiveMultiText = false;
						end
					end
					
					local receiveSound = true;
					if (target == lastSoundReceivedFrom) then
						local Time = GetTime() - lastSoundReceivedTime;
						if (Time < timeBetweenReceives) then
							receiveSound = false;
						end
					end
					
					local receiveMultiSound = true;
					if (target == lastMultiSoundReceivedFrom) then
						local Time = GetTime() - lastMultiSoundReceivedTime;
						if (Time < timeBetweenReceives) then
							receiveMultiSound = false;
						end
					end
					
					local sendVersionResponse = true;
					if (target == lastVersionResponseSendTo) then
						local Time = GetTime() - lastVersionResponseSendToTime;
						if (Time < timeBetweenReceives) then
							sendVersionResponse = false;
						end
					end
				-- check if it isn't a multi-send ===================================
				
				
				receive = "";
				if ((receiveText == true) or (receiveSound == true)) then
					-- receives =====================================================
						-- other ====================================================
							if (solo == false) then
								
								if (prefix == "kshot_StreakAnnounceEvent") then
									if (receiveText == true) then
										kshot:Print(text);
										receive = "text";
									end
								end
								
							end
						-- other ====================================================
						-- scrolling text events ====================================
							if (solo == false) then
								
								if (receiveText == true) then
									if (OtherKillMessages == true) then
										if (prefix == Prefix..Prefix_Guild..Prefix_Kill..Prefix_Text) then
											if (ReceiveFromGuild == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "text";
											end
										elseif (prefix == Prefix..Prefix_Raid..Prefix_Kill..Prefix_Text) then
											if (ReceiveFromRaid == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "text";
											end
										elseif (prefix == Prefix..Prefix_BG..Prefix_Kill..Prefix_Text) then
											if (ReceiveFromBG == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "text";
											end
										end
									end
								end
								if (receiveMultiText == true) then
									if (OtherMultiKillMessages == true) then
										if (prefix == Prefix..Prefix_Guild..Prefix_MultiKill..Prefix_Text) then
											if (ReceiveFromGuild == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "multi-text";
											end
										elseif (prefix == Prefix..Prefix_Raid..Prefix_MultiKill..Prefix_Text) then
											if (ReceiveFromRaid == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "multi-text";
											end
										elseif (prefix == Prefix..Prefix_BG..Prefix_MultiKill..Prefix_Text) then
											if (ReceiveFromBG == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "multi-text";
											end
										end
									end
								end
								if (receiveText == true) then
									if (OtherDeathMessages == true) then
										if (prefix == Prefix..Prefix_Guild..Prefix_Death..Prefix_Text) then
											if (ReceiveDeathsFromGuild == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "text";
											end
										elseif (prefix == Prefix..Prefix_Raid..Prefix_Death..Prefix_Text) then
											if (ReceiveDeathsFromRaid == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "text";
											end
										elseif (prefix == Prefix..Prefix_BG..Prefix_Death..Prefix_Text) then
											if (ReceiveDeathsFromBG == true) then
												kshot:ScrollText(text, false);
												kshot:ChatText(text);
												receive = "text";
											end
										end
									end
								end
								
							end
						-- scrolling text events ====================================
						-- sound events =============================================
							if (solo == false) then
								
								if (receiveSound == true) then
									if (OtherKillSounds == true) then
										if (prefix == Prefix..Prefix_Guild..Prefix_Kill..Prefix_Sound) then
											if (ReceiveFromGuild == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										elseif (prefix == Prefix..Prefix_Raid..Prefix_Kill..Prefix_Sound) then
											if (ReceiveFromRaid == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										elseif (prefix == Prefix..Prefix_BG..Prefix_Kill..Prefix_Sound) then
											if (ReceiveFromBG == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										end
									end
								end
								if (receiveMultiSound == true) then
									if (OtherMultiKillSounds == true) then
										if (prefix == Prefix..Prefix_Guild..Prefix_MultiKill..Prefix_Sound) then
											if (ReceiveFromGuild == true) then
												kshot:PlaySound(text);
												receive = "multi-sound";
											end
										elseif (prefix == Prefix..Prefix_Raid..Prefix_MultiKill..Prefix_Sound) then
											if (ReceiveFromRaid == true) then
												kshot:PlaySound(text);
												receive = "multi-sound";
											end
										elseif (prefix == Prefix..Prefix_BG..Prefix_MultiKill..Prefix_Sound) then
											if (ReceiveFromBG == true) then
												kshot:PlaySound(text);
												receive = "multi-sound";
											end
										end
									end
								end
								if (receiveSound == true) then
									if (OtherDeathSounds == true) then
										if (prefix == Prefix..Prefix_Guild..Prefix_Death..Prefix_Sound) then
											if (ReceiveFromGuild == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										elseif (prefix == Prefix..Prefix_Raid..Prefix_Death..Prefix_Sound) then
											if (ReceiveFromRaid == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										elseif (prefix == Prefix..Prefix_BG..Prefix_Death..Prefix_Sound) then
											if (ReceiveFromBG == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										end
									end
								end
								
							end
						-- sound events =============================================
						-- version data =============================================
							if (sendVersionResponse == true) then
								if (prefix == Prefix..Prefix_Guild..Prefix_VersionRequest) then
									kshot:SendVersionResponse(text, "GUILD");
									receive = "version";
								elseif (prefix == Prefix..Prefix_Raid..Prefix_VersionRequest) then
									if (kshot:Raid(true) == true) then
										kshot:SendVersionResponse(text, "RAID");
										receive = "version";
									elseif (kshot:Party(true) == true) then
										kshot:SendVersionResponse(text, "PARTY");
										receive = "version";
									end
								elseif (prefix == Prefix..Prefix_BG..Prefix_VersionRequest) then
									kshot:SendVersionResponse(text, "BATTLEGROUND");
									receive = "version";
								end
							end
							
							if (prefix == Prefix..Prefix_VersionResponse) then
								local nameLength = string.len(playername);
								if (playername == string.sub(text, 0, nameLength)) then
									local startIndex = nameLength + 2;
									kshot:Print(string.sub(text, startIndex));
								end
							end
						-- version data =============================================
					-- receives =====================================================
				end
				
				
				-- for multi-send check =============================================
					if (receive == "text") then
						lastTextReceivedFrom = target;
						lastTextReceivedTime = GetTime();
					elseif (receive == "sound") then
						lastSoundReceivedFrom = target;
						lastSoundReceivedTime = GetTime();
					elseif (receive == "multi-text") then
						lastMultiTextReceivedFrom = target;
						lastMultiTextReceivedTime = GetTime();
					elseif (receive == "multi-sound") then
						lastMultiSoundReceivedFrom = target;
						lastMultiSoundReceivedTime = GetTime();
					elseif (receive == "version") then
						lastVersionResponseSendTo = target;
						lastVersionResponseSendToTime = GetTime();
					end
				-- for multi-send check =============================================
				
			end
		end
	-- events ============================================================================================================
	
	-- kill / death ======================================================================================================
		function kshot:KillshotPvE()
			if (PvE == true) then
				local soundnr = 0;
				if (PvE_Random == true) then
					soundnr = math.random(1, audiofiles);
					soundnr = 0-100-soundnr;
				else
					killingstreakPvE = killingstreakPvE + 1;
					if (killingstreakPvE > audiofiles) then
						killingstreakPvE = 1;
					end
					soundnr = killingstreakPvE;
				end
				kshot:PlaySound(kshot:GetSoundLink(soundnr));
			end
		end
		
		function kshot:KillshotPvP(killer, victim)
			if (PvP == true) then
				local takeScreenshot = false;
				
				-- kill ====================================================================
					-- modify vars ======
						killingstreak = killingstreak + 1;
						totalkillingblows = totalkillingblows + 1;
						
						if (killingstreak == 1) then
							killingstreaktimes = killingstreaktimes + 1;
						end
					-- modify vars ======
					
					local kill_msg = kshot:getStreakMessage(victim, killingstreak);
					
					-- addon actions ====
						if (emote == true) then
							SendChatMessage( kill_msg, "EMOTE");
						end
						if (YourKillMessages == true) then
							kshot:ScrollText("You " ..  kill_msg, false);
							kshot:ChatText("You " ..  kill_msg);
						end
						if (YourKillSounds == true) then
							kshot:PlaySound(kshot:GetSoundLink(killingstreak));
						end
						
						if (killingstreak > maxkillingstreak) then
							maxkillingstreak = killingstreak;
							kshot:ScrollText("You have set a new record!", true);
							kshot:ChatText("You have set a new record!");
							
							if (ScreenshotOnNewHighestStreak == true) then
								takeScreenshot = true;
							end
						end
						
						if (ScreenshotOnKill == true) then
							takeScreenshot = true;
						end
					-- addon actions ====
					
					-- share ======
						if (solo == false) then
							if (kshot:Guild(SendToGuild) == true) then
								SendAddonMessage(Prefix..Prefix_Guild..Prefix_Kill..Prefix_Text, killer .. " " ..  kill_msg, "GUILD");
								SendAddonMessage(Prefix..Prefix_Guild..Prefix_Kill..Prefix_Sound, kshot:GetSoundLink(killingstreak), "GUILD");
							end
							if (kshot:Party(SendToRaid) == true) then
								SendAddonMessage(Prefix..Prefix_Raid..Prefix_Kill..Prefix_Text, killer .. " " ..  kill_msg, "PARTY");
								SendAddonMessage(Prefix..Prefix_Raid..Prefix_Kill..Prefix_Sound, kshot:GetSoundLink(killingstreak), "PARTY");
							end
							if (kshot:Raid(SendToRaid) == true) then
								SendAddonMessage(Prefix..Prefix_Raid..Prefix_Kill..Prefix_Text, killer .. " " ..  kill_msg, "RAID");
								SendAddonMessage(Prefix..Prefix_Raid..Prefix_Kill..Prefix_Sound, kshot:GetSoundLink(killingstreak), "RAID");
							end
							if (kshot:BG(SendToBG) == true) then
								SendAddonMessage(Prefix..Prefix_BG..Prefix_Kill..Prefix_Text, killer .. " " ..  kill_msg, "BATTLEGROUND");
								SendAddonMessage(Prefix..Prefix_BG..Prefix_Kill..Prefix_Sound, kshot:GetSoundLink(killingstreak), "BATTLEGROUND");
							end
						end
					-- share ======
				-- kill ====================================================================
				
				-- multikill ===============================================================
					-- check multikill + modify vars ==
						local thismultikill = false;
						local Time = GetTime() - lastKill;
						if (Time < multikillTime) then
							multistreak = multistreak + 1;
							totalmultistreak = totalmultistreak + 1;
							thismultikill = true;
						else
							multistreak = 0;
						end
						lastKill = GetTime();
					-- check multikill + modify vars ==
					
					local multi_msg = "scored a MULTIKILL!!! Multi-Streak of " .. multistreak .. "!";
					
					if (thismultikill == true) then
						-- addon actions ====
							if (emote == true) then
								SendChatMessage(multi_msg, "EMOTE");
							end
							if (YourMultiKillMessages == true) then
								kshot:ScrollText("You " .. multi_msg, true);
								kshot:ChatText("You " .. multi_msg);
							end
							if (YourMultiKillSounds == true) then
								kshot:PlaySound(multikillSound);
							end
							
							if (multistreak > maxmultistreak) then
								maxmultistreak = multistreak;
								kshot:ScrollText("You have set a new multi-streak record!", true);
								kshot:ChatText("You have set a new multi-streak record!");
								
								if (ScreenshotOnNewHighestMultiStreak == true) then
									takeScreenshot = true;
								end
							end
							
							if (ScreenshotOnMultiKill == true) then
								takeScreenshot = true;
							end
						-- addon actions ====
						
						-- share ======
							if (solo == false) then
								if (kshot:Guild(SendToGuild) == true) then
									SendAddonMessage(Prefix..Prefix_Guild..Prefix_MultiKill..Prefix_Text, killer .. " " ..  multi_msg, "GUILD");
									SendAddonMessage(Prefix..Prefix_Guild..Prefix_MultiKill..Prefix_Sound, "sp0-1.mp3", "GUILD");
								end
								if (kshot:Party(SendToRaid) == true) then
									SendAddonMessage(Prefix..Prefix_Raid..Prefix_MultiKill..Prefix_Text, killer .. " " ..  multi_msg, "PARTY");
									SendAddonMessage(Prefix..Prefix_Raid..Prefix_MultiKill..Prefix_Sound, "sp0-1.mp3", "PARTY");
								end
								if (kshot:Raid(SendToRaid) == true) then
									SendAddonMessage(Prefix..Prefix_Raid..Prefix_MultiKill..Prefix_Text, killer .. " " ..  multi_msg, "RAID");
									SendAddonMessage(Prefix..Prefix_Raid..Prefix_MultiKill..Prefix_Sound, "sp0-1.mp3", "RAID");
								end
								if (kshot:BG(SendToBG) == true) then
									SendAddonMessage(Prefix..Prefix_BG..Prefix_MultiKill..Prefix_Text, killer .. " " ..  multi_msg, "BATTLEGROUND");
									SendAddonMessage(Prefix..Prefix_BG..Prefix_MultiKill..Prefix_Sound, "sp0-1.mp3", "BATTLEGROUND");
								end
							end
						-- share ======
					end
				-- multikill ===============================================================
				
				if (takeScreenshot == true) then
					kshot:Screenshot();
				end
			end
		end
		
		function kshot:PlayerDeath(killer)
			killingstreak = 0;
			multistreak = 0;
			
			local msg = " got pwned by " .. killer .. "!";
			if (killer == "") then
				msg = " got pwned!";
			end
			
			if (YourDeathMessages == true) then
				kshot:ScrollText("You" .. msg, true);
				kshot:ChatText("You" .. msg);
			end
			if (YourDeathSounds == true) then
				kshot:PlaySound(kshot:GetSoundLink(killingstreak));
			end
			
			if (solo == false) then
				kshot:checkPlayerName();
				if (kshot:Guild(SendToGuild) == true) then
					SendAddonMessage(Prefix..Prefix_Guild..Prefix_Death..Prefix_Text, playername .. msg, "GUILD");
					SendAddonMessage(Prefix..Prefix_Guild..Prefix_Death..Prefix_Sound, kshot:GetSoundLink(killingstreak), "GUILD");
				end
				if (kshot:Party(SendToRaid) == true) then
					SendAddonMessage(Prefix..Prefix_Raid..Prefix_Death..Prefix_Text, playername .. msg, "PARTY");
					SendAddonMessage(Prefix..Prefix_Raid..Prefix_Death..Prefix_Sound, kshot:GetSoundLink(killingstreak), "PARTY");
				end
				if (kshot:Raid(SendToRaid) == true) then
					SendAddonMessage(Prefix..Prefix_Raid..Prefix_Death..Prefix_Text, playername .. msg, "RAID");
					SendAddonMessage(Prefix..Prefix_Raid..Prefix_Death..Prefix_Sound, kshot:GetSoundLink(killingstreak), "RAID");
				end
				if (kshot:BG(SendToBG) == true) then
					SendAddonMessage(Prefix..Prefix_BG..Prefix_Death..Prefix_Text, playername .. msg, "BATTLEGROUND");
					SendAddonMessage(Prefix..Prefix_BG..Prefix_Death..Prefix_Sound, kshot:GetSoundLink(killingstreak), "BATTLEGROUND");
				end
			end
			
			if (ScreenshotOnDeath == true) then
				kshot:Screenshot();
			end
		end
	-- kill / death ======================================================================================================
-- main script ===========================================================================================================


-- check functions =======================================================================================================
	function kshot:Guild(Guild)
		local GuildOK = false;
		if (Guild == true) then
			local numTotalMembers,numOnlineMembers = GetNumGuildMembers();
			if ((IsInGuild() == 1) or (numTotalMembers > 0)) then
				GuildOK = true;
			end
		end
		return GuildOK;
	end
	function kshot:Party(Raid)
		local PartyOK = false;
		if (Raid == true) then
			if (GetRealNumPartyMembers() > 0) then
				PartyOK = true;
			end
		end
		return PartyOK;
	end
	function kshot:Raid(Raid)
		local RaidOK = false;
		if (Raid == true) then
			if (GetRealNumRaidMembers() > 0) then
				RaidOK = true;
			end
		end
		return RaidOK;
	end
	function kshot:BG(BG)
		local BGOK = false;
		if (BG == true) then
			if (GetNumBattlefieldScores() > 0) then
				BGOK = true;
			else
				local status, mapName, instanceID, minlevel, maxlevel;
				for i=1, MAX_BATTLEFIELD_QUEUES do
					status, mapName, instanceID, minlevel, maxlevel, teamSize = GetBattlefieldStatus(i);
					if (status == "active") then
						BGOK = true;
					end
				end
			end
		end
		return BGOK;
	end
	function kshot:Arena(Arena)
		local ArenaOK = false;
		if (Arena == true) then
			local a,b = IsActiveBattlefieldArena();
			if (a == 1) then
				ArenaOK = true;
			end
		end
		return ArenaOK;
	end
	function kshot:CheckBoolean(what, boolean)
		if ((boolean == true) or (boolean == 1)) then
			kshot:Print(what .. " = true");
		else
			kshot:Print(what .. " = false");
		end
	end
-- check functions =======================================================================================================


-- important functions (changed often) ===================================================================================
	function kshot:Test()
		if (testGivesRealKill == true) then
			kshot:checkPlayerName();
			kshot:KillshotPvP(playername, testVictim);
		else
			local killingstreaktest = math.random(1, 25);
			local message = kshot:getStreakMessage(testVictim, killingstreaktest);
			
			if (emote == true) then
				SendChatMessage(message, "EMOTE");
			end
			if (YourKillMessages == true) then
				kshot:ScrollText("You " .. message, false);
				kshot:ChatText("You " .. message);
			end
			if (YourKillSounds == true) then
				kshot:PlaySound(kshot:GetSoundLink(killingstreaktest));
			end
			
			-- if (ScreenshotOnKill == true) then
			--	kshot:Screenshot();
			-- end
		end
	end
	
	function kshot:ResetStreak()
		killingstreak = 0;
		killingstreakPvE = 0;
		multistreak = 0;
		kshot:Print("Your Killshot streak has been resetted");
	end
	
	function kshot:ResetStreakInfo()
		killingstreak = 0;
		killingstreakPvE = 0;
		multistreak = 0;
		maxmultistreak = 0;
		totalmultistreak = 0;
		maxkillingstreak = 0;
		totalkillingblows = 0;
		killingstreaktimes = 0;
		kshot:Print("Your streak data has been deleted");
	end
	
	function kshot:ResetAll()
		saved = currentSavedVar;
		
		soundpack = "sp1normal";
		randomKillMessages = 1;
		killMessage1 = "pwned $v! Streak of $s!";
		killMessage2 = "pwned $v! Streak of $s!";
		killMessage3 = "pwned $v! Streak of $s!";
		killMessage4 = "pwned $v! Streak of $s!";
		killMessage5 = "pwned $v! Streak of $s!";
		killMessage6 = "pwned $v! Streak of $s!";
		killMessage7 = "pwned $v! Streak of $s!";
		killMessage8 = "pwned $v! Streak of $s!";
		killMessage9 = "pwned $v! Streak of $s!";
		killMessage10 = "pwned $v! Streak of $s!";
		
		sound = true;
		scrollingtext = true;
		chattext = true;
		emote = true;
		solo = false;
		
		PvP = true;
		PvE = false;
		PvE_Random = false;
		
		ScreenshotOnKill = false;
		ScreenshotOnMultiKill = true;
		ScreenshotOnDeath = false;
		ScreenshotOnNewHighestStreak = true;
		ScreenshotOnNewHighestMultiStreak = true;
		
		ResetStreakOnLogin = false;
		ResetStreakOnZoneChange = false;
		
		ShowStreakOnLogin = true;
		ShowStreakOnZoneChange = true;
		
		sendwhat = "streak1";
		StreakAnnounceGuild = true;
		StreakAnnounceRaid = true;
		StreakAnnounceBG = true;
		
		SendToGuild = true;
		SendToRaid = true;
		SendToBG = true;
		ReceiveFromGuild = true;
		ReceiveFromRaid = true;
		ReceiveFromBG = true;
		ReceiveDeathsFromGuild = true;
		ReceiveDeathsFromRaid = true;
		ReceiveDeathsFromBG = true;
		
		CheckVersionGuild = true;
		CheckVersionRaid = true;
		CheckVersionBG = true;
		
		YourKillMessages = true;
		YourKillSounds = true;
		OtherKillMessages = true;
		OtherKillSounds = true;
		
		YourMultiKillMessages = true;
		YourMultiKillSounds = true;
		OtherMultiKillMessages = true;
		OtherMultiKillSounds = true;
		
		YourDeathMessages = true;
		YourDeathSounds = true;
		OtherDeathMessages = true;
		OtherDeathSounds = true;
		
		executeSoundNPC = true;
		executeSoundPlayer = true;
		
		killingstreak = 0;
		killingstreakPvE = 0;
		multistreak = 0;
		maxmultistreak = 0;
		totalmultistreak = 0;
		maxkillingstreak = 0;
		totalkillingblows = 0;
		killingstreaktimes = 0;
		kshot:Print("Killshot detected a new user");
	end
-- important functions (changed often) ===================================================================================